> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Create a new resource model

POST https://example.itential.io/lifecycle-manager/resources
Content-Type: application/json

Creates a new resource model.

Reference: https://docs.itential.com/itential-cloud/api-reference/lifecycle-manager/create-resource-model-http

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Body (application/json)

This endpoint expects an object.

- `name` (string, required) — The name of the resource model
- `description` (string, optional, default: ) — Free-form text describing the resource model
- `schema` (any, optional) — A draft-07 JSON Schema which defines the validation applied to instances of the resource model
- `actions` (list of object, optional)
  - `name` (string, required) — The name of the action
  - `type` (enum, required) — The type of the action
    - Allowed values: `create`, `update`, `delete`
  - `preWorkflowJst` (string, required, nullable) — Optional transformation to be applied to incoming parameters before providing them to the workflow.
  - `postWorkflowJst` (string, required, nullable) — Optional transformation to be applied to the workflow's outputs before updating the instance.
  - `workflow` (any or string, required, nullable) — The _id of the workflow to use as the implementation of this action. If the asset cannot be found during import the name is used in place of the _id
  - `_id` (any, optional) — The identifier of an action
  - `description` (string, optional, default: ) — Free-form text describing the purpose of the action

## Response

### 200

response

- `data` (object, optional)
  - `_id` (any, required)
  - `name` (string, required) — The name of the resource model
  - `description` (string, required, default: ) — Free-form text describing the resource model
  - `schema` (any, required) — A draft-07 JSON Schema which defines the validation applied to instances of the resource model
  - `created` (any, required) — An ISO date string denoting when this resource model was created
  - `createdBy` (any, required) — The account identifier of the user who created this resource model
  - `lastUpdated` (any, required) — An ISO date string denoting when this resource model was last updated
  - `lastUpdatedBy` (any, required) — The account identifier of the user who last updated this resource model
  - `actions` (list of object, optional)
    - `_id` (any, required) — The identifier of an action
    - `name` (string, required) — The name of the action
    - `type` (enum, required) — The type of the action
      - Allowed values: `create`, `update`, `delete`
    - `preWorkflowJst` (string, required, nullable) — Optional transformation to be applied to incoming parameters before providing them to the workflow.
    - `postWorkflowJst` (string, required, nullable) — Optional transformation to be applied to the workflow's outputs before updating the instance.
    - `description` (string, optional, default: ) — Free-form text describing the purpose of the action
    - `inputSchema` (object, optional) — The schema describing inputs to this action
    - `outputSchema` (object, optional) — The schema describing inputs to this action

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{
  "name": "VLAN Service"
}
```

**Response**

```json
{
  "data": {
    "name": "VLAN Service",
    "description": "This resource model represents something we use on a day-to-day basis.",
    "schema": null,
    "created": null,
    "createdBy": null,
    "lastUpdated": null,
    "lastUpdatedBy": null,
    "actions": [
      {
        "_id": null,
        "name": "Create",
        "type": "create",
        "preWorkflowJst": "62a1f3d2ebedfc54e6e0065c",
        "postWorkflowJst": "62a1f3d2ebedfc54e6e0065c",
        "description": "Creates a new VLAN service instance",
        "inputSchema": {},
        "outputSchema": {},
        "workflow": null
      }
    ]
  },
  "message": "Successfully created the requested item",
  "metadata": {}
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/lifecycle-manager/resources"

payload = { "name": "VLAN Service" }
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/lifecycle-manager/resources';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"name":"VLAN Service"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/lifecycle-manager/resources"

	payload := strings.NewReader("{\n  \"name\": \"VLAN Service\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/lifecycle-manager/resources")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"VLAN Service\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://example.itential.io/lifecycle-manager/resources")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"VLAN Service\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://example.itential.io/lifecycle-manager/resources', [
  'body' => '{
  "name": "VLAN Service"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/lifecycle-manager/resources");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"VLAN Service\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = ["name": "VLAN Service"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/lifecycle-manager/resources")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```